package data;

public enum GigafidaJosWordType {
	SAMOSTALNIK("samostalnik", 'S'),
	GLAGOL("glagol", 'G'),
	PRIDEVNIK("pridevnik", 'P'),
	PRISLOV("prislov", 'R'),
	ZAIMEK("zaimek", 'Z'),
	STEVNIK("stevnik", 'K'),
	PREDLOG("predlog", 'D'),
	VEZNIK("veznik", 'V'),
	CLENEK("clenek", 'L'),
	MEDMET("medmet", 'M'),
	OKRAJSAVA("okrajsava", 'O');


	private final String name;
	private final char wordType;

	GigafidaJosWordType(String name, char wordType) {
		this.name = name;
		this.wordType = wordType;
	}

	public String toString() {
		return this.name;
	}

	public char getWordType() {
		return wordType;
	}

	public static GigafidaJosWordType factory(String wType) {
		if (wType != null) {
			if (SAMOSTALNIK.toString().equals(wType)) {
				return SAMOSTALNIK;
			}
			if (GLAGOL.toString().equals(wType)) {
				return GLAGOL;
			}
			if (PRIDEVNIK.toString().equals(wType)) {
				return PRIDEVNIK;
			}
			if (PRISLOV.toString().equals(wType)) {
				return PRISLOV;
			}
			if (ZAIMEK.toString().equals(wType)) {
				return ZAIMEK;
			}
			if (STEVNIK.toString().equals(wType)) {
				return STEVNIK;
			}
			if (PREDLOG.toString().equals(wType)) {
				return PREDLOG;
			}
			if (VEZNIK.toString().equals(wType)) {
				return VEZNIK;
			}
			if (CLENEK.toString().equals(wType)) {
				return CLENEK;
			}
			if (MEDMET.toString().equals(wType)) {
				return MEDMET;
			}
			if (OKRAJSAVA.toString().equals(wType)) {
				return OKRAJSAVA;
			}
		}
		return null;
	}
}
